/*****************************************************
This program was produced by the
CodeWizardAVR V1.25.7 beta 5 Professional
Automatic Program Generator
 Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project : 
Version : 
Date    : 09.08.2008
Author  : F4CG                            
Company : F4CG                            
Comments: 

Chip type           : ATmega8
Program type        : Application
Clock frequency     : 8,00 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

// Declare your global variables here
char eeprom *ptr_to_eeprom;
unsigned char ticReadData=0; 

unsigned char flag=0;
#define readData_0D     0x80
#define USARTreadData   0x40
#define str_default     0x20
#define ENDStrDefault   0x10

#define StartAdrEEPROM          0x0F
#define DelayOutSimbol_to_LCD   400		//200 //        .
#define maxLenStr               255


flash unsigned char ConvertWinFont[]={0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,0xA5,0xA6,0x4B,0xA7,
0x4D,0x48,0x4F,0xA8,0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,0xAC,0xE2,0xAD,0xAE,0x62,0xAF,0xB0,0xB1,
0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,0x70,0x63,0xBF,0x79,
0xE4,0x78,0xE5,0xC0,0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7};

char DataBuff[280]={"                   "};
char *ptrDataBuff=&DataBuff[0];
char *ptrOutLCD_Buff=&DataBuff[0];

interrupt [USART_RXC] void usartRX(void)
{
char data;

    data=UDR;
    flag |= USARTreadData;
    if (flag & readData_0D)
    {
        if (data==0x0A)
        {
            //ENDreciveStr(); 
            for (data=0; data<16; data++)
                *ptrDataBuff++=0x20;   
    
            *ptrDataBuff=0;
            ptrDataBuff=&DataBuff[0];
            ptr_to_eeprom=0;
            ptr_to_eeprom+=StartAdrEEPROM;
            *ptr_to_eeprom++=0;
            
            while(*ptrDataBuff)
                *ptr_to_eeprom++=*ptrDataBuff++; 
                   
            *ptr_to_eeprom=0;
            ptrDataBuff=&DataBuff[0];
            ptr_to_eeprom=0;
            ptr_to_eeprom+=StartAdrEEPROM;
            ptr_to_eeprom++;
            ptrOutLCD_Buff=&DataBuff[0];
            lcd_gotoxy(0,1);
            lcd_putsf("                ");
            flag &= ~USARTreadData;
            ticReadData=0;  
        }
        flag &= ~readData_0D;    
        return;
    }
    if (data==0x0D)
    {
        flag |= readData_0D;
        return;
    }
    if (ticReadData < maxLenStr)
    {
        *ptrDataBuff=data;
        ptrDataBuff++;
        ticReadData++;
    }
    else     
        flag &= ~readData_0D;
}

void beg_stroka(void)
{
unsigned char i;

//    
        for(i=0;i<17;i++)
            lcd_write_byte(0xC0+i,lcd_read_byte(0xC1+i));
        
//        
        lcd_gotoxy(15,1);
         
        switch (i=*ptrOutLCD_Buff)
        {
            case 168:
                i=0xA2;
                break;
            case 184:
                i=0xB5;
                break;
            default:
                if (i>=192)
                    i=ConvertWinFont[i-192];
                else
                    i=*ptrOutLCD_Buff;
        }
         
        lcd_putchar(i);
        if(!(*(++ptrOutLCD_Buff)))
        {
            ptrOutLCD_Buff=&DataBuff[0];
            if (!(flag & str_default))
                flag |= str_default;
        }
}

void init_AVR(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x00;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: Off
// USART Mode: Asynchronous
// USART Baud Rate: 9600
UCSRA=0x00;
UCSRB=0x90;
UCSRC=0x86;
UBRRH=0x00;
UBRRL=0x33;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
}


void main(void)
{
// Declare your local variables here

// Place your code here

    init_AVR();
    lcd_init(16);   // LCD module initialization
    lcd_gotoxy(0,0);
    lcd_putsf("WINSTAR DISPLAYS");
    #asm("sei")
    
    while (1)
    {
        if (!(flag & str_default))
            break;
        
        ptrOutLCD_Buff=&DataBuff[0];
        ptr_to_eeprom=0;
        ptr_to_eeprom+=StartAdrEEPROM;
        if (!(*ptr_to_eeprom++))
        {
            while(*ptr_to_eeprom)
                *ptrOutLCD_Buff++=*ptr_to_eeprom++;
            *ptrOutLCD_Buff=0;
            ptrOutLCD_Buff=&DataBuff[0];
            ptr_to_eeprom=0;
            ptr_to_eeprom+=StartAdrEEPROM;
            ptr_to_eeprom++;
        }
        break;
    }

    while (1)
    {
        while (flag & USARTreadData);
        if (!(flag & ENDStrDefault))
        {
            if (flag & str_default)
            {
                flag |= ENDStrDefault;
                ptrOutLCD_Buff=&DataBuff[0];
                ptr_to_eeprom=0;
                ptr_to_eeprom+=StartAdrEEPROM;
                if (!(*ptr_to_eeprom++))
                {
                    while(*ptr_to_eeprom)
                        *ptrOutLCD_Buff++=*ptr_to_eeprom++;
                    *ptrOutLCD_Buff=0;
                    ptrOutLCD_Buff=&DataBuff[0];
                    ptr_to_eeprom=0;
                    ptr_to_eeprom+=StartAdrEEPROM;
                    ptr_to_eeprom++;
                }
            }
        }
        delay_ms(DelayOutSimbol_to_LCD);
        beg_stroka();
    }
}
